/** Mozile Component Test Script
 * @fileoverview This file contains JSUnit test functions for testing the MozileEditor object.
 * Requires MozileComponentUtils.js
 * 
 * @link http://mozile.mozdev.org 
 * @author James A. Overton <james@overton.ca>
 * @version 0.7.0
 */


var name = "DummyModule";

/** Test - Constructor
 * Test the constructor and basic methods.
 */

function testConstructor() {
	var component = new MozileEditor(name);
	checkComponentBasics(component);
}



/** Test - Options
 * Test getting and setting options.
 */
function testOptions() {
	var configString = "DummyModule garbage text";
	var component = new MozileEditor(configString);
	checkOptions(component);
}


function testInsertDelete() {
	var component = mozileEditor;
	resetSelection();
	
	var node = document.getElementById("target2").firstChild;
	var original = node.textContent;
	component.insertString("k");
	assertEquals("Text should be changed.", "k"+original, node.textContent);
	component.deletion("previous");
	assertEquals("Text should be restored.", original, node.textContent);
}

// insertString
// insertFragment
// deletion
// splitBlock
// seekIP
// seekTextNode


function resetSelection() {
	var node = document.getElementById("target2").firstChild;
	var offset = 0;
	var selection = window.getSelection();
	var range = document.createRange();
	
	range.setStart(node, offset);
	selection.removeAllRanges();
	selection.addRange(range);
}